//Define variables
var tumblet = {
	api_url : 'http://www.tumblr.com/api/write',
	email : null,
	password : null,
	xml_request : null,
	registry : null
};

var postSent = false;

function loadSettings(){
	tumblet.registry = new RegistryObj();
	tumblet.email = tumblet.registry.readStringValue("email");
	tumblet.password = tumblet.registry.readStringValue("password");	
}

function init(){
	loadSettings();
	if(System.Gadget.settingsUI == ''){
		System.Gadget.settingsUI = "settings.html";
	}
	
	if(!tumblet.email || !tumblet.password || (tumblet.email == '') || (tumblet.password == '')){
		System.Gadget.document.getElementById("infoText").innerHTML = 'Go to settings and enter your email and password to start using this gadget.';
		System.Gadget.document.getElementById("infoText").style.visibility = "visible";
		System.Gadget.document.getElementById("header").style.visibility = "hidden";
		System.Gadget.document.getElementById("addPage").style.visibility = "hidden";
	}else{
		System.Gadget.document.getElementById("infoText").innerHTML = '';
		System.Gadget.document.getElementById("infoText").style.visibility = "hidden";		
		System.Gadget.document.getElementById("header").style.visibility = "visible";
		System.Gadget.document.getElementById("addPage").style.visibility = "visible";
	}
}


System.Gadget.onSettingsClosed = function(event){	
	if (event.closeAction == event.Action.commit){
		if(!tumblet.email || !tumblet.password || (tumblet.email == '') || (tumblet.password == '')){
			System.Gadget.document.getElementById("infoText").innerHTML = 'Go to settings and enter your email and password to start using this gadget.';
			System.Gadget.document.getElementById("infoText").style.visibility = "visible";
			System.Gadget.document.getElementById("header").style.visibility = "hidden";
			System.Gadget.document.getElementById("addPage").style.visibility = "hidden";
		}else{
			System.Gadget.document.getElementById("infoText").innerHTML = '';
			System.Gadget.document.getElementById("infoText").style.visibility = "hidden";		
			System.Gadget.document.getElementById("header").style.visibility = "visible";
			System.Gadget.document.getElementById("addPage").style.visibility = "visible";
		}
	}
}

System.Gadget.Flyout.onHide = function(){
	System.Gadget.document.parentWindow.focus();
}

System.Gadget.Flyout.onShow = function(){
	
}

function showFlyout(fType){	
	System.Gadget.beginTransition();
	switch(fType){
		case 'text':			
			System.Gadget.Flyout.file = "flyout_1.html";
			break;
		case 'photo':			
			System.Gadget.Flyout.file = "flyout_2.html";
			break;
		case 'quote':			
			System.Gadget.Flyout.file = "flyout_3.html";
			break;
		case 'link':			
			System.Gadget.Flyout.file = "flyout_4.html";
			break;
		case 'chat':			
			System.Gadget.Flyout.file = "flyout_5.html";
			break;
		case 'video':			
			System.Gadget.Flyout.file = "flyout_6.html";
			break;		
	}
	
	if(!System.Gadget.Flyout.show){				
		System.Gadget.Flyout.show = true;		
	}			
	var sec = new Number(1);
	System.Gadget.endTransition(System.Gadget.TransitionType.none, sec);
}

function initFlyout(){
	loadSettings();
	setTimeout("getFocus()", 300);
}

function getFocus(){
	self.focus();
}

function updateRT_BODY(val){
	document.getElementById("RT_BODY").value = val;
}

function sendPost(pt){
	var error_string = '';
			
	if (tumblet.xml_request != null) {
		tumblet.xml_request.abort();
		tumblet.xml_request = null;
	}		

	if (tumblet.email !== "" && tumblet.password !== "") {
		
		
		tumblet.xml_request = new XMLHttpRequest();
		tumblet.xml_request.onload = function(e) {
		    if (tumblet.xml_request.status == 201) {
		        postSent = true;
		    } else if (tumblet.xml_request.status == 403) {
		        error_string = 'Access denied';
		    } else {
		        error_string = 'Server error';				
		    }
		}
		var requestStr = 'generator=' + escape('VistaTumblet/0.0.0.2') + '&email=' + tumblet.email + '&password=' + tumblet.password;
		switch(pt){
			case 1:
				requestStr += '&type=regular' + '&title=' + escape(document.getElementById("title").value) + '&body=' + escape(document.getElementById("RT_BODY").value);				
				break;
			case 2:				
				requestStr += '&type=photo' + '&source=' + escape(document.getElementById("image_url").value) + '&caption=' + escape(document.getElementById("RT_BODY").value);				
				break;
			case 3:				
				requestStr += '&type=quote' +  '&quote=' + escape(document.getElementById("quote").value) + '&source=' + escape(document.getElementById("RT_BODY").value);				
				break;
			case 4:				
				requestStr += '&type=link' + '&name=' + escape(document.getElementById("link_name").value) + '&url=' + escape(document.getElementById("link_url").value) + '&description=' + escape(document.getElementById("RT_BODY").value);
				break;
			case 5:				
				requestStr += '&type=conversation' + '&title=' + escape(document.getElementById("chat_title").value) + '&conversation=' + escape(document.getElementById("chat_dialogue").value);				
				break;
			case 6:				
				requestStr += '&type=video' + '&embed=' + escape(document.getElementById("video_url").value) + '&caption=' + escape(document.getElementById("RT_BODY").value);				
				break;			
		}
		tumblet.xml_request.open("POST", tumblet.api_url, true);
		tumblet.xml_request.setRequestHeader("Cache-Control", "no-cache");
		tumblet.xml_request.setRequestHeader('Content-type','application/x-www-form-urlencoded');
		tumblet.xml_request.send(requestStr);
		//psInterval = setInterval("check_postSent()", 100);
	}
}

function hideFlyout(){
	System.Gadget.Flyout.show = false;
}

function check_postSent(){
	if(postSent){
		clearInterval(psInterval);
		postSent = false;
		hideFlyout();
	}
}

function doNothing(){
	
}